/*===================== begin_copyright_notice ==================================

Copyright (c) 2017 Intel Corporation

Permission is hereby granted, free of charge, to any person obtaining a
copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


======================= end_copyright_notice ==================================*/


// SVML code
/*
//               INTEL CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or
//  nondisclosure agreement with Intel Corporation and may not be copied
//  or disclosed except in accordance with the terms of that agreement.
//    Copyright (C) 1996-2010 Intel Corporation. All Rights Reserved.
//
*/



#ifndef __SVML_POWER_DATA_CL__
#define __SVML_POWER_DATA_CL__

/*
//               INTEL CORPORATION PROPRIETARY INFORMATION
//  This software is supplied under the terms of a license agreement or
//  nondisclosure agreement with Intel Corporation and may not be copied
//  or disclosed except in accordance with the terms of that agreement.
//    Copyright (C) 1996-2010 Intel Corporation. All Rights Reserved.
//
*/

#include "_svml_data_structures.cl"

typedef struct
{

    VUINT32 sHiMask;
    VUINT32 sRSValue;
    VUINT32 NMINNORM;
    VUINT32 NMAXVAL;
    VUINT32 INF;

    VUINT32 LFR_TBL[65][3];
    VUINT32 LFR_I_CHK_WORK_SUB;
    VUINT32 LFR_I_CHK_WORK_CMP;
    VUINT32 S_MANT_MASK;
    VUINT32 S_ONE;
    VUINT32 LFR_I_INDEX_MASK;
    VUINT32 LFR_I_INDEX_ADD;
    VUINT32 S_HI10BITS_MASK;
    VUINT32 LFR_S_P4;
    VUINT32 LFR_S_P3;
    VUINT32 LFR_S_P2;
    VUINT32 I_BIAS;
    VUINT32 LFR_I_NZ_ADD;
    VUINT32 LFR_I_NZ_CMP;
    VUINT32 S_LOG2_HI;
    VUINT32 S_LOG2_LO;

    VUINT32 _sInvLn2;
    VUINT32 _sShifter;
    VUINT32 _sLn2hi;
    VUINT32 _sLn2lo;
    VUINT32 _sPC0;
    VUINT32 _sPC1;
    VUINT32 _sPC2;
    VUINT32 _sPC3;
    VUINT32 _sPC4;
    VUINT32 _sPC5;
    VUINT32 _iBias;
    VUINT32 _iAbsMask;
    VUINT32 _iDomainRange;
    VUINT32 _s2N_2;
    VUINT32 _sHuge;
    VUINT32 _sTiny;

}
sPow_Table_Type;

__constant sPow_Table_Type __ocl_svml_spow_data =
{

    (VUINT32) (0xFFFFF000u),
    (VUINT32) (0x45800800u),
    (VUINT32) (0x80800000u),
    (VUINT32) (0xfeffffffu),
    (VUINT32) (0x7f800000u),

    {
        {(VUINT32) (0x00000000u),
         (VUINT32) (0x00000000u),
         (VUINT32) (0x3F800000u)},
        {(VUINT32) (0x3C810000u),
         (VUINT32) (0x35ACB127u),
         (VUINT32) (0x3F7C0000u)},
        {(VUINT32) (0x3D020000u),
         (VUINT32) (0x372EC4F4u),
         (VUINT32) (0x3F780000u)},
        {(VUINT32) (0x3D33C000u),
         (VUINT32) (0x38129E5Bu),
         (VUINT32) (0x3F750000u)},
        {(VUINT32) (0x3D774000u),
         (VUINT32) (0x378C7002u),
         (VUINT32) (0x3F710000u)},
        {(VUINT32) (0x3D9DE000u),
         (VUINT32) (0x37FAD3E9u),
         (VUINT32) (0x3F6D0000u)},
        {(VUINT32) (0x3DB80000u),
         (VUINT32) (0x37530AEBu),
         (VUINT32) (0x3F6A0000u)},
        {(VUINT32) (0x3DD26000u),
         (VUINT32) (0x381D902Cu),
         (VUINT32) (0x3F670000u)},
        {(VUINT32) (0x3DED2000u),
         (VUINT32) (0x3849D8E1u),
         (VUINT32) (0x3F640000u)},
        {(VUINT32) (0x3E08B000u),
         (VUINT32) (0x38474114u),
         (VUINT32) (0x3F600000u)},
        {(VUINT32) (0x3E168000u),
         (VUINT32) (0x38308643u),
         (VUINT32) (0x3F5D0000u)},
        {(VUINT32) (0x3E248000u),
         (VUINT32) (0x381EC19Au),
         (VUINT32) (0x3F5A0000u)},
        {(VUINT32) (0x3E2DF000u),
         (VUINT32) (0x382035AAu),
         (VUINT32) (0x3F580000u)},
        {(VUINT32) (0x3E3C4000u),
         (VUINT32) (0x3846C2A2u),
         (VUINT32) (0x3F550000u)},
        {(VUINT32) (0x3E4AD000u),
         (VUINT32) (0x3735B9EEu),
         (VUINT32) (0x3F520000u)},
        {(VUINT32) (0x3E598000u),
         (VUINT32) (0x386C2BAEu),
         (VUINT32) (0x3F4F0000u)},
        {(VUINT32) (0x3E637000u),
         (VUINT32) (0x387DE378u),
         (VUINT32) (0x3F4D0000u)},
        {(VUINT32) (0x3E729000u),
         (VUINT32) (0x38077FF4u),
         (VUINT32) (0x3F4A0000u)},
        {(VUINT32) (0x3E7CC000u),
         (VUINT32) (0x380E365Au),
         (VUINT32) (0x3F480000u)},
        {(VUINT32) (0x3E862000u),
         (VUINT32) (0x37359D86u),
         (VUINT32) (0x3F450000u)},
        {(VUINT32) (0x3E8B5800u),
         (VUINT32) (0x37B9975Au),
         (VUINT32) (0x3F430000u)},
        {(VUINT32) (0x3E90A000u),
         (VUINT32) (0x378ADA1Du),
         (VUINT32) (0x3F410000u)},
        {(VUINT32) (0x3E95F000u),
         (VUINT32) (0x38707CDDu),
         (VUINT32) (0x3F3F0000u)},
        {(VUINT32) (0x3E9E1000u),
         (VUINT32) (0x37A4EE66u),
         (VUINT32) (0x3F3C0000u)},
        {(VUINT32) (0x3EA38800u),
         (VUINT32) (0x380DC272u),
         (VUINT32) (0x3F3A0000u)},
        {(VUINT32) (0x3EA91000u),
         (VUINT32) (0x382E0739u),
         (VUINT32) (0x3F380000u)},
        {(VUINT32) (0x3EAEA800u),
         (VUINT32) (0x383DDF59u),
         (VUINT32) (0x3F360000u)},
        {(VUINT32) (0x3EB45000u),
         (VUINT32) (0x38483E9Cu),
         (VUINT32) (0x3F340000u)},
        {(VUINT32) (0x3EBA0800u),
         (VUINT32) (0x385876C6u),
         (VUINT32) (0x3F320000u)},
        {(VUINT32) (0x3EBFD000u),
         (VUINT32) (0x387A3BD8u),
         (VUINT32) (0x3F300000u)},
        {(VUINT32) (0x3EC5B000u),
         (VUINT32) (0x3766A22Du),
         (VUINT32) (0x3F2E0000u)},
        {(VUINT32) (0x3ECB9800u),
         (VUINT32) (0x38234313u),
         (VUINT32) (0x3F2C0000u)},
        {(VUINT32) (0x3ECE9800u),
         (VUINT32) (0x372FA858u),
         (VUINT32) (0x3F2B0000u)},
        {(VUINT32) (0x3ED49800u),
         (VUINT32) (0x386D3C8Bu),
         (VUINT32) (0x3F290000u)},
        {(VUINT32) (0x3EDAB000u),
         (VUINT32) (0x387A0446u),
         (VUINT32) (0x3F270000u)},
        {(VUINT32) (0x3EE0E000u),
         (VUINT32) (0x37C0D27Fu),
         (VUINT32) (0x3F250000u)},
        {(VUINT32) (0x3EE3F800u),
         (VUINT32) (0x3879C745u),
         (VUINT32) (0x3F240000u)},
        {(VUINT32) (0x3EEA4800u),
         (VUINT32) (0x3511B7BFu),
         (VUINT32) (0x3F220000u)},
        {(VUINT32) (0x3EED7000u),
         (VUINT32) (0x37EA9099u),
         (VUINT32) (0x3F210000u)},
        {(VUINT32) (0x3EF3D800u),
         (VUINT32) (0x378587BBu),
         (VUINT32) (0x3F1F0000u)},
        {(VUINT32) (0x3EF71000u),
         (VUINT32) (0x382156B4u),
         (VUINT32) (0x3F1E0000u)},
        {(VUINT32) (0x3EFD9800u),
         (VUINT32) (0x37B15EF5u),
         (VUINT32) (0x3F1C0000u)},
        {(VUINT32) (0x3F007000u),
         (VUINT32) (0x3835CB64u),
         (VUINT32) (0x3F1B0000u)},
        {(VUINT32) (0x3F03C400u),
         (VUINT32) (0x37FC14CFu),
         (VUINT32) (0x3F190000u)},
        {(VUINT32) (0x3F057000u),
         (VUINT32) (0x386DC5A1u),
         (VUINT32) (0x3F180000u)},
        {(VUINT32) (0x3F08D400u),
         (VUINT32) (0x3870478Fu),
         (VUINT32) (0x3F160000u)},
        {(VUINT32) (0x3F0A8C00u),
         (VUINT32) (0x3807EDE5u),
         (VUINT32) (0x3F150000u)},
        {(VUINT32) (0x3F0C4400u),
         (VUINT32) (0x385C81E4u),
         (VUINT32) (0x3F140000u)},
        {(VUINT32) (0x3F0FC000u),
         (VUINT32) (0x3846BF8Cu),
         (VUINT32) (0x3F120000u)},
        {(VUINT32) (0x3F118400u),
         (VUINT32) (0x37C362FBu),
         (VUINT32) (0x3F110000u)},
        {(VUINT32) (0x3F134800u),
         (VUINT32) (0x3844226Au),
         (VUINT32) (0x3F100000u)},
        {(VUINT32) (0x3F16DC00u),
         (VUINT32) (0x386AAF62u),
         (VUINT32) (0x3F0E0000u)},
        {(VUINT32) (0x3F18AC00u),
         (VUINT32) (0x38348868u),
         (VUINT32) (0x3F0D0000u)},
        {(VUINT32) (0x3F1A8000u),
         (VUINT32) (0x37A2B676u),
         (VUINT32) (0x3F0C0000u)},
        {(VUINT32) (0x3F1C5400u),
         (VUINT32) (0x38442E33u),
         (VUINT32) (0x3F0B0000u)},
        {(VUINT32) (0x3F1E3000u),
         (VUINT32) (0x3680C36Cu),
         (VUINT32) (0x3F0A0000u)},
        {(VUINT32) (0x3F200C00u),
         (VUINT32) (0x3761092Eu),
         (VUINT32) (0x3F090000u)},
        {(VUINT32) (0x3F23D000u),
         (VUINT32) (0x37293F45u),
         (VUINT32) (0x3F070000u)},
        {(VUINT32) (0x3F25B400u),
         (VUINT32) (0x387ADF2Eu),
         (VUINT32) (0x3F060000u)},
        {(VUINT32) (0x3F27A000u),
         (VUINT32) (0x383506B5u),
         (VUINT32) (0x3F050000u)},
        {(VUINT32) (0x3F299000u),
         (VUINT32) (0x37B89A1Au),
         (VUINT32) (0x3F040000u)},
        {(VUINT32) (0x3F2B8000u),
         (VUINT32) (0x38744D77u),
         (VUINT32) (0x3F030000u)},
        {(VUINT32) (0x3F2D7800u),
         (VUINT32) (0x3800B86Du),
         (VUINT32) (0x3F020000u)},
        {(VUINT32) (0x3F2F7400u),
         (VUINT32) (0x35AA8906u),
         (VUINT32) (0x3F010000u)},
        {(VUINT32) (0x3F317000u),
         (VUINT32) (0x3805FDF4u),
         (VUINT32) (0x3F000000u)},
    },
    (VUINT32) (0x80800000u),
    (VUINT32) (0xFF000000u),
    (VUINT32) (0x007fffffu),
    (VUINT32) (0x3f800000u),
    (VUINT32) (0x007F0000u),
    (VUINT32) (0x00010000u),
    (VUINT32) (0x7fffc000u),
    (VUINT32) (0xBE800000u),
    (VUINT32) (0x3EAAAAABu),
    (VUINT32) (0xBF000000u),
    (VUINT32) (0x0000007fu),
    (VUINT32) (0x407e0000u),
    (VUINT32) (0x7ffc0000u),
    (VUINT32) (0x3F317000u),
    (VUINT32) (0x3805FDF4u),

    (VUINT32) (0x3FB8AA3Bu),
    (VUINT32) (0x4b400000u),
    (VUINT32) (0x3F317200u),
    (VUINT32) (0x35BFBE8Eu),
    (VUINT32) (0x3F800000u),
    (VUINT32) (0x3F7FFFFEu),
    (VUINT32) (0x3EFFFF34u),
    (VUINT32) (0x3E2AACACu),
    (VUINT32) (0x3D2B8392u),
    (VUINT32) (0x3C07D9FEu),
    (VUINT32) (0x0000007fu),
    (VUINT32) (0x7fffffffu),
    (VUINT32) (0x42819f00u),
    (VUINT32) (0x33800000u),
    (VUINT32) (0x7f7fffffu),
    (VUINT32) (0x00800000u)

};

__constant VUINT32 _vmlsPowHATab[380] =
{

    0x3F800000,
    0x3F640000,
    0x3F4C0000,
    0x3F3A0000,
    0x3F2A0000,
    0x3F1E0000,
    0x3F120000,
    0x3F080000,
    0x3F000000,

    0x00000000,
    0x00000000,
    0x3E2B1E00,
    0x36614FFD,
    0x3EA7B700,
    0x36DD9676,
    0x3EEBF300,
    0x3640ABC3,
    0xBED19B00,
    0xB6B053FB,
    0xBE9B8900,
    0xB599D49A,
    0xBE426000,
    0xB6AF40BC,
    0xBDB31C00,
    0xB6EDF592,
    0x00000000,
    0x00000000,

    0x3F800000,
    0x3F780000,
    0x3F700000,
    0x3F8A0000,
    0x3F880000,
    0x3F860000,
    0x3F840000,
    0x3F820000,
    0x3F800000,

    0x00000000,
    0x00000000,
    0x3D3B9800,
    0x3694C9D9,
    0x3DBEB000,
    0x3492D9F7,
    0xBDDE4000,
    0xB684815B,
    0xBDB31C00,
    0xB6EDF592,
    0xBD875800,
    0xB6627E8A,
    0xBD35D000,
    0xB6D3758F,
    0xBCB73000,
    0xB6CB42E1,
    0x00000000,
    0x00000000,

    0x3FB88000,
    0x3FB7C000,
    0x3FB70000,
    0x3FB64000,
    0x3FB5C000,
    0x3FBC8000,
    0x3FBC4000,
    0x3FBBC000,
    0x3FBB8000,
    0x3FBB0000,
    0x3FBAC000,
    0x3FBA4000,
    0x3FBA0000,
    0x3FB98000,
    0x3FB94000,
    0x3FB8C000,
    0x3FB88000,

    0x00000000,
    0x00000000,
    0x3BC08000,
    0x3601B0EA,
    0x3C40E000,
    0x36A82CE1,
    0x3C910000,
    0x35F27427,
    0x3CB17000,
    0x36BBF0CC,
    0xBCFD7000,
    0xB6DA84F4,
    0xBCEDC000,
    0xB6E53CD7,
    0xBCCE5000,
    0xB6FA51D3,
    0xBCBEA000,
    0xB4074B50,
    0xBC9F1000,
    0xB52D128E,
    0xBC8F4000,
    0xB5655E44,
    0xBC5F2000,
    0xB59903D9,
    0xBC3F6000,
    0xB5A1551A,
    0xBBFF8000,
    0xB5979427,
    0xBBBFC000,
    0xB5839E88,
    0xBB000000,
    0xB4E32477,
    0x00000000,
    0x00000000,

    0x3F800000,
    0x00000000,
    0x3F80B1EE,
    0xB3B02666,
    0x3F8164D2,
    0xB1C43FD0,
    0x3F8218B0,
    0xB3BC8C04,
    0x3F82CD86,
    0x3398AC2C,
    0x3F83835A,
    0xB3B11049,
    0x3F843A28,
    0x33C3ACDE,
    0x3F84F1F6,
    0x332C6F38,
    0x3F85AAC4,
    0xB39833B8,
    0x3F866492,
    0xB3A46DC0,
    0x3F871F62,
    0xB352C2E6,
    0x3F87DB36,
    0xB3800967,
    0x3F88980E,
    0x338092DB,
    0x3F8955EE,
    0x30D86398,
    0x3F8A14D6,
    0xB38AB691,
    0x3F8AD4C6,
    0x330A58E5,
    0x3F8B95C2,
    0xB260ABA1,
    0x3F8C57CA,
    0xB2EE6E43,
    0x3F8D1AE0,
    0xB3A481A4,
    0x3F8DDF04,
    0x32808B9A,
    0x3F8EA43A,
    0xB3697465,
    0x3F8F6A82,
    0xB3E81937,
    0x3F9031DC,
    0x330628CD,
    0x3F90FA4C,
    0x338BEEE5,
    0x3F91C3D4,
    0xB38C54EE,
    0x3F928E72,
    0x337B2A64,
    0x3F935A2C,
    0xB3D0EC19,
    0x3F942700,
    0xB3F054E4,
    0x3F94F4F0,
    0xB32E0212,
    0x3F95C3FE,
    0x3386D6CC,
    0x3F96942E,
    0xB3C8DFE8,
    0x3F97657E,
    0xB3B60E85,
    0x3F9837F0,
    0x33231B71,
    0x3F990B88,
    0xB26CC9F4,
    0x3F99E046,
    0xB359BE90,
    0x3F9AB62A,
    0x33FC9500,
    0x3F9B8D3A,
    0xB30C5563,
    0x3F9C6574,
    0xB397D13D,
    0x3F9D3EDA,
    0xB331A601,
    0x3F9E196E,
    0x3244EA39,
    0x3F9EF532,
    0x33412342,
    0x3F9FD228,
    0x32959003,
    0x3FA0B052,
    0xB3F0468F,
    0x3FA18FAE,
    0x33CA8545,
    0x3FA27044,
    0xB3FCF3B7,
    0x3FA35210,
    0xB39717FD,
    0x3FA43516,
    0xB323EC33,
    0x3FA51958,
    0xB37282C2,
    0x3FA5FED6,
    0x33A9B151,
    0x3FA6E594,
    0x33CFEEE8,
    0x3FA7CD94,
    0xB3162D36,
    0x3FA8B6D6,
    0xB3E984CE,
    0x3FA9A15A,
    0x33B4EA7C,
    0x3FAA8D26,
    0x3325D921,
    0x3FAB7A3A,
    0xB314AD82,
    0x3FAC6896,
    0x33A4BE40,
    0x3FAD583E,
    0x33EA42A1,
    0x3FAE4934,
    0x3325946B,
    0x3FAF3B78,
    0x33AD690A,
    0x3FB02F0E,
    0xB2D1247F,
    0x3FB123F6,
    0xB37C5AA8,
    0x3FB21A32,
    0xB33333CE,
    0x3FB311C4,
    0x32154889,
    0x3FB40AAE,
    0x33A2654C,
    0x3FB504F4,
    0xB3CC0622,
    0x3FB60094,
    0xB32F4254,
    0x3FB6FD92,
    0xB266B974,
    0x3FB7FBF0,
    0xB2D5CD70,
    0x3FB8FBB0,
    0xB3B89D04,
    0x3FB9FCD2,
    0x330A5817,
    0x3FBAFF5A,
    0x33B2133E,
    0x3FBC034A,
    0x337DE5D4,
    0x3FBD08A4,
    0xB3414FE8,
    0x3FBE0F68,
    0x31986099,
    0x3FBF179A,
    0xB3130B1A,
    0x3FC0213A,
    0x33A1F0D1,
    0x3FC12C4C,
    0x33CA6671,
    0x3FC238D2,
    0x32C478F6,
    0x3FC346CC,
    0x33DA2497,
    0x3FC4563E,
    0x33CC5335,
    0x3FC5672A,
    0x320AA837,
    0x3FC67990,
    0x33B5AA24,
    0x3FC78D74,
    0x33C8ABBA,
    0x3FC8A2D8,
    0x33391FFC,
    0x3FC9B9BE,
    0xB37323A2,
    0x3FCAD226,
    0x333C8521,
    0x3FCBEC14,
    0x33FEF272,
    0x3FCD078C,
    0xB3735F84,
    0x3FCE248C,
    0x3228FC24,
    0x3FCF4318,
    0x33CF1919,
    0x3FD06334,
    0xB2944353,
    0x3FD184E0,
    0xB39DAE96,
    0x3FD2A81E,
    0xB35C1DAA,
    0x3FD3CCF0,
    0x3399859B,
    0x3FD4F35A,
    0x33ABCFEE,
    0x3FD61B5E,
    0xB0303219,
    0x3FD744FC,
    0x33CAD69D,
    0x3FD8703A,
    0xB3B3924D,
    0x3FD99D16,
    0xB2F61D41,
    0x3FDACB94,
    0x335E5594,
    0x3FDBFBB8,
    0xB3504A1C,
    0x3FDD2D82,
    0xB375EF9B,
    0x3FDE60F4,
    0x33825E0F,
    0x3FDF9612,
    0x33DEB8F0,
    0x3FE0CCDE,
    0x33EC2A95,
    0x3FE2055A,
    0x33FFFE84,
    0x3FE33F8A,
    0xB38D4176,
    0x3FE47B6C,
    0x33A0373E,
    0x3FE5B906,
    0x33E77C83,
    0x3FE6F85A,
    0x33AAEE20,
    0x3FE8396A,
    0x33207898,
    0x3FE97C38,
    0x3300D89F,
    0x3FEAC0C6,
    0x33E7DD24,
    0x3FEC0718,
    0x33B64C1D,
    0x3FED4F30,
    0x3276CCA1,
    0x3FEE9910,
    0xB34FE4BA,
    0x3FEFE4BA,
    0xB348464A,
    0x3FF13230,
    0x33A7AD09,
    0x3FF28178,
    0xB3C3A600,
    0x3FF3D290,
    0xB2871670,
    0x3FF5257E,
    0xB3EADB79,
    0x3FF67A42,
    0xB3938CC0,
    0x3FF7D0E0,
    0xB38CF52F,
    0x3FF9295A,
    0xB3094457,
    0x3FFA83B2,
    0x33DB722A,
    0x3FFBDFEE,
    0xB3931A0F,
    0x3FFD3E0C,
    0x31CF486C,
    0x3FFE9E12,
    0xB3A38470,

    0x3A6A6369,
    0xBEB1C35D,
    0x3E246F69,
    0xBDAB1EA1,

    0x3F317218,
    0x3E75FDF0,
    0x3D635847,

    0x7F000000,
    0x00800000,
    0x00000000,
    0x3F800000,
    0xBF800000,

    0x47C00000,

    0x3FB88000,

    0x45800800,

    0x5F800000,
    0x1F800000,
    0x00000000,
    0x80000000,
};


typedef struct
{

  uint sHiMask;
  uint sRSValue;
  uint NMINNORM;
  uint NMAXVAL;
  uint INF;

  uint LFR_TBL[65][3][1];
  uint LFR_I_CHK_WORK_SUB;
  uint LFR_I_CHK_WORK_CMP;
  uint S_MANT_MASK;
  uint S_ONE;
  uint LFR_I_INDEX_MASK;
  uint LFR_I_INDEX_ADD;
  uint S_HI10BITS_MASK;
  uint LFR_S_P4;
  uint LFR_S_P3;
  uint LFR_S_P2;
  uint I_BIAS;
  uint LFR_I_NZ_ADD;
  uint LFR_I_NZ_CMP;
  uint S_LOG2_HI;
  uint S_LOG2_LO;

  uint _sInvLn2;
  uint _sShifter;
  uint _sLn2hi;
  uint _sLn2lo;
  uint _sPC0;
  uint _sPC1;
  uint _sPC2;
  uint _sPC3;
  uint _sPC4;
  uint _sPC5;
  uint _iBias;
  uint _iAbsMask;
  uint _iDomainRange;
  uint _s2N_2;
  uint _sHuge;
  uint _sTiny;

} sRootn_Table_Type;

__constant sRootn_Table_Type __ocl_svml_srootn_data = {

  (uint) (0xFFFFF000u),
  (uint) (0x45800800u),
  (uint) (0x80800000u),
  (uint) (0xfeffffffu),
  (uint) (0x7f800000u),

  {
   {{(uint) (0x00000000u)},
    {(uint) (0x00000000u)},
    {(uint) (0x3F800000u)}},
   {{(uint) (0x3C810000u)},
    {(uint) (0x35ACB127u)},
    {(uint) (0x3F7C0000u)}},
   {{(uint) (0x3D020000u)},
    {(uint) (0x372EC4F4u)},
    {(uint) (0x3F780000u)}},
   {{(uint) (0x3D33C000u)},
    {(uint) (0x38129E5Bu)},
    {(uint) (0x3F750000u)}},
   {{(uint) (0x3D774000u)},
    {(uint) (0x378C7002u)},
    {(uint) (0x3F710000u)}},
   {{(uint) (0x3D9DE000u)},
    {(uint) (0x37FAD3E9u)},
    {(uint) (0x3F6D0000u)}},
   {{(uint) (0x3DB80000u)},
    {(uint) (0x37530AEBu)},
    {(uint) (0x3F6A0000u)}},
   {{(uint) (0x3DD26000u)},
    {(uint) (0x381D902Cu)},
    {(uint) (0x3F670000u)}},
   {{(uint) (0x3DED2000u)},
    {(uint) (0x3849D8E1u)},
    {(uint) (0x3F640000u)}},
   {{(uint) (0x3E08B000u)},
    {(uint) (0x38474114u)},
    {(uint) (0x3F600000u)}},
   {{(uint) (0x3E168000u)},
    {(uint) (0x38308643u)},
    {(uint) (0x3F5D0000u)}},
   {{(uint) (0x3E248000u)},
    {(uint) (0x381EC19Au)},
    {(uint) (0x3F5A0000u)}},
   {{(uint) (0x3E2DF000u)},
    {(uint) (0x382035AAu)},
    {(uint) (0x3F580000u)}},
   {{(uint) (0x3E3C4000u)},
    {(uint) (0x3846C2A2u)},
    {(uint) (0x3F550000u)}},
   {{(uint) (0x3E4AD000u)},
    {(uint) (0x3735B9EEu)},
    {(uint) (0x3F520000u)}},
   {{(uint) (0x3E598000u)},
    {(uint) (0x386C2BAEu)},
    {(uint) (0x3F4F0000u)}},
   {{(uint) (0x3E637000u)},
    {(uint) (0x387DE378u)},
    {(uint) (0x3F4D0000u)}},
   {{(uint) (0x3E729000u)},
    {(uint) (0x38077FF4u)},
    {(uint) (0x3F4A0000u)}},
   {{(uint) (0x3E7CC000u)},
    {(uint) (0x380E365Au)},
    {(uint) (0x3F480000u)}},
   {{(uint) (0x3E862000u)},
    {(uint) (0x37359D86u)},
    {(uint) (0x3F450000u)}},
   {{(uint) (0x3E8B5800u)},
    {(uint) (0x37B9975Au)},
    {(uint) (0x3F430000u)}},
   {{(uint) (0x3E90A000u)},
    {(uint) (0x378ADA1Du)},
    {(uint) (0x3F410000u)}},
   {{(uint) (0x3E95F000u)},
    {(uint) (0x38707CDDu)},
    {(uint) (0x3F3F0000u)}},
   {{(uint) (0x3E9E1000u)},
    {(uint) (0x37A4EE66u)},
    {(uint) (0x3F3C0000u)}},
   {{(uint) (0x3EA38800u)},
    {(uint) (0x380DC272u)},
    {(uint) (0x3F3A0000u)}},
   {{(uint) (0x3EA91000u)},
    {(uint) (0x382E0739u)},
    {(uint) (0x3F380000u)}},
   {{(uint) (0x3EAEA800u)},
    {(uint) (0x383DDF59u)},
    {(uint) (0x3F360000u)}},
   {{(uint) (0x3EB45000u)},
    {(uint) (0x38483E9Cu)},
    {(uint) (0x3F340000u)}},
   {{(uint) (0x3EBA0800u)},
    {(uint) (0x385876C6u)},
    {(uint) (0x3F320000u)}},
   {{(uint) (0x3EBFD000u)},
    {(uint) (0x387A3BD8u)},
    {(uint) (0x3F300000u)}},
   {{(uint) (0x3EC5B000u)},
    {(uint) (0x3766A22Du)},
    {(uint) (0x3F2E0000u)}},
   {{(uint) (0x3ECB9800u)},
    {(uint) (0x38234313u)},
    {(uint) (0x3F2C0000u)}},
   {{(uint) (0x3ECE9800u)},
    {(uint) (0x372FA858u)},
    {(uint) (0x3F2B0000u)}},
   {{(uint) (0x3ED49800u)},
    {(uint) (0x386D3C8Bu)},
    {(uint) (0x3F290000u)}},
   {{(uint) (0x3EDAB000u)},
    {(uint) (0x387A0446u)},
    {(uint) (0x3F270000u)}},
   {{(uint) (0x3EE0E000u)},
    {(uint) (0x37C0D27Fu)},
    {(uint) (0x3F250000u)}},
   {{(uint) (0x3EE3F800u)},
    {(uint) (0x3879C745u)},
    {(uint) (0x3F240000u)}},
   {{(uint) (0x3EEA4800u)},
    {(uint) (0x3511B7BFu)},
    {(uint) (0x3F220000u)}},
   {{(uint) (0x3EED7000u)},
    {(uint) (0x37EA9099u)},
    {(uint) (0x3F210000u)}},
   {{(uint) (0x3EF3D800u)},
    {(uint) (0x378587BBu)},
    {(uint) (0x3F1F0000u)}},
   {{(uint) (0x3EF71000u)},
    {(uint) (0x382156B4u)},
    {(uint) (0x3F1E0000u)}},
   {{(uint) (0x3EFD9800u)},
    {(uint) (0x37B15EF5u)},
    {(uint) (0x3F1C0000u)}},
   {{(uint) (0x3F007000u)},
    {(uint) (0x3835CB64u)},
    {(uint) (0x3F1B0000u)}},
   {{(uint) (0x3F03C400u)},
    {(uint) (0x37FC14CFu)},
    {(uint) (0x3F190000u)}},
   {{(uint) (0x3F057000u)},
    {(uint) (0x386DC5A1u)},
    {(uint) (0x3F180000u)}},
   {{(uint) (0x3F08D400u)},
    {(uint) (0x3870478Fu)},
    {(uint) (0x3F160000u)}},
   {{(uint) (0x3F0A8C00u)},
    {(uint) (0x3807EDE5u)},
    {(uint) (0x3F150000u)}},
   {{(uint) (0x3F0C4400u)},
    {(uint) (0x385C81E4u)},
    {(uint) (0x3F140000u)}},
   {{(uint) (0x3F0FC000u)},
    {(uint) (0x3846BF8Cu)},
    {(uint) (0x3F120000u)}},
   {{(uint) (0x3F118400u)},
    {(uint) (0x37C362FBu)},
    {(uint) (0x3F110000u)}},
   {{(uint) (0x3F134800u)},
    {(uint) (0x3844226Au)},
    {(uint) (0x3F100000u)}},
   {{(uint) (0x3F16DC00u)},
    {(uint) (0x386AAF62u)},
    {(uint) (0x3F0E0000u)}},
   {{(uint) (0x3F18AC00u)},
    {(uint) (0x38348868u)},
    {(uint) (0x3F0D0000u)}},
   {{(uint) (0x3F1A8000u)},
    {(uint) (0x37A2B676u)},
    {(uint) (0x3F0C0000u)}},
   {{(uint) (0x3F1C5400u)},
    {(uint) (0x38442E33u)},
    {(uint) (0x3F0B0000u)}},
   {{(uint) (0x3F1E3000u)},
    {(uint) (0x3680C36Cu)},
    {(uint) (0x3F0A0000u)}},
   {{(uint) (0x3F200C00u)},
    {(uint) (0x3761092Eu)},
    {(uint) (0x3F090000u)}},
   {{(uint) (0x3F23D000u)},
    {(uint) (0x37293F45u)},
    {(uint) (0x3F070000u)}},
   {{(uint) (0x3F25B400u)},
    {(uint) (0x387ADF2Eu)},
    {(uint) (0x3F060000u)}},
   {{(uint) (0x3F27A000u)},
    {(uint) (0x383506B5u)},
    {(uint) (0x3F050000u)}},
   {{(uint) (0x3F299000u)},
    {(uint) (0x37B89A1Au)},
    {(uint) (0x3F040000u)}},
   {{(uint) (0x3F2B8000u)},
    {(uint) (0x38744D77u)},
    {(uint) (0x3F030000u)}},
   {{(uint) (0x3F2D7800u)},
    {(uint) (0x3800B86Du)},
    {(uint) (0x3F020000u)}},
   {{(uint) (0x3F2F7400u)},
    {(uint) (0x35AA8906u)},
    {(uint) (0x3F010000u)}},
   {{(uint) (0x3F317000u)},
    {(uint) (0x3805FDF4u)},
    {(uint) (0x3F000000u)}},
   },
  (uint) (0x80800000u),
  (uint) (0xFF000000u),
  (uint) (0x007fffffu),
  (uint) (0x3f800000u),
  (uint) (0x007F0000u),
  (uint) (0x00010000u),
  (uint) (0x7fffc000u),
  (uint) (0xBE800000u),
  (uint) (0x3EAAAAABu),
  (uint) (0xBF000000u),
  (uint) (0x0000007fu),
  (uint) (0x407e0000u),
  (uint) (0x7ffc0000u),
  (uint) (0x3F317000u),
  (uint) (0x3805FDF4u),

  (uint) (0x3FB8AA3Bu),
  (uint) (0x4b400000u),
  (uint) (0x3F317200u),
  (uint) (0x35BFBE8Eu),
  (uint) (0x3F800000u),
  (uint) (0x3F7FFFFEu),
  (uint) (0x3EFFFF34u),
  (uint) (0x3E2AACACu),
  (uint) (0x3D2B8392u),
  (uint) (0x3C07D9FEu),
  (uint) (0x0000007fu),
  (uint) (0x7fffffffu),
  (uint) (0x42ae9a00u),
  (uint) (0x33800000u),
  (uint) (0x7f7fffffu),
  (uint) (0x00800000u)

};



__constant _iml_sp_union_t _vmlsRootnHATab[380] = {

  { 0x3F800000 },
  { 0x3F640000 },
  { 0x3F4C0000 },
  { 0x3F3A0000 },
  { 0x3F2A0000 },
  { 0x3F1E0000 },
  { 0x3F120000 },
  { 0x3F080000 },
  { 0x3F000000 },

  { 0x00000000 },
  { 0x00000000 },
  { 0x3E2B1E00 },
  { 0x36614FFD },
  { 0x3EA7B700 },
  { 0x36DD9676 },
  { 0x3EEBF300 },
  { 0x3640ABC3 },
  { 0xBED19B00 },
  { 0xB6B053FB },
  { 0xBE9B8900 },
  { 0xB599D49A },
  { 0xBE426000 },
  { 0xB6AF40BC },
  { 0xBDB31C00 },
  { 0xB6EDF592 },
  { 0x00000000 },
  { 0x00000000 },

  { 0x3F800000 },
  { 0x3F780000 },
  { 0x3F700000 },
  { 0x3F8A0000 },
  { 0x3F880000 },
  { 0x3F860000 },
  { 0x3F840000 },
  { 0x3F820000 },
  { 0x3F800000 },

  { 0x00000000 },
  { 0x00000000 },
  { 0x3D3B9800 },
  { 0x3694C9D9 },
  { 0x3DBEB000 },
  { 0x3492D9F7 },
  { 0xBDDE4000 },
  { 0xB684815B },
  { 0xBDB31C00 },
  { 0xB6EDF592 },
  { 0xBD875800 },
  { 0xB6627E8A },
  { 0xBD35D000 },
  { 0xB6D3758F },
  { 0xBCB73000 },
  { 0xB6CB42E1 },
  { 0x00000000 },
  { 0x00000000 },

  { 0x3FB88000 },
  { 0x3FB7C000 },
  { 0x3FB70000 },
  { 0x3FB64000 },
  { 0x3FB5C000 },
  { 0x3FBC8000 },
  { 0x3FBC4000 },
  { 0x3FBBC000 },
  { 0x3FBB8000 },
  { 0x3FBB0000 },
  { 0x3FBAC000 },
  { 0x3FBA4000 },
  { 0x3FBA0000 },
  { 0x3FB98000 },
  { 0x3FB94000 },
  { 0x3FB8C000 },
  { 0x3FB88000 },

  { 0x00000000 },
  { 0x00000000 },
  { 0x3BC08000 },
  { 0x3601B0EA },
  { 0x3C40E000 },
  { 0x36A82CE1 },
  { 0x3C910000 },
  { 0x35F27427 },
  { 0x3CB17000 },
  { 0x36BBF0CC },
  { 0xBCFD7000 },
  { 0xB6DA84F4 },
  { 0xBCEDC000 },
  { 0xB6E53CD7 },
  { 0xBCCE5000 },
  { 0xB6FA51D3 },
  { 0xBCBEA000 },
  { 0xB4074B50 },
  { 0xBC9F1000 },
  { 0xB52D128E },
  { 0xBC8F4000 },
  { 0xB5655E44 },
  { 0xBC5F2000 },
  { 0xB59903D9 },
  { 0xBC3F6000 },
  { 0xB5A1551A },
  { 0xBBFF8000 },
  { 0xB5979427 },
  { 0xBBBFC000 },
  { 0xB5839E88 },
  { 0xBB000000 },
  { 0xB4E32477 },
  { 0x00000000 },
  { 0x00000000 },

  { 0x3F800000 },
  { 0x00000000 },
  { 0x3F80B1EE },
  { 0xB3B02666 },
  { 0x3F8164D2 },
  { 0xB1C43FD0 },
  { 0x3F8218B0 },
  { 0xB3BC8C04 },
  { 0x3F82CD86 },
  { 0x3398AC2C },
  { 0x3F83835A },
  { 0xB3B11049 },
  { 0x3F843A28 },
  { 0x33C3ACDE },
  { 0x3F84F1F6 },
  { 0x332C6F38 },
  { 0x3F85AAC4 },
  { 0xB39833B8 },
  { 0x3F866492 },
  { 0xB3A46DC0 },
  { 0x3F871F62 },
  { 0xB352C2E6 },
  { 0x3F87DB36 },
  { 0xB3800967 },
  { 0x3F88980E },
  { 0x338092DB },
  { 0x3F8955EE },
  { 0x30D86398 },
  { 0x3F8A14D6 },
  { 0xB38AB691 },
  { 0x3F8AD4C6 },
  { 0x330A58E5 },
  { 0x3F8B95C2 },
  { 0xB260ABA1 },
  { 0x3F8C57CA },
  { 0xB2EE6E43 },
  { 0x3F8D1AE0 },
  { 0xB3A481A4 },
  { 0x3F8DDF04 },
  { 0x32808B9A },
  { 0x3F8EA43A },
  { 0xB3697465 },
  { 0x3F8F6A82 },
  { 0xB3E81937 },
  { 0x3F9031DC },
  { 0x330628CD },
  { 0x3F90FA4C },
  { 0x338BEEE5 },
  { 0x3F91C3D4 },
  { 0xB38C54EE },
  { 0x3F928E72 },
  { 0x337B2A64 },
  { 0x3F935A2C },
  { 0xB3D0EC19 },
  { 0x3F942700 },
  { 0xB3F054E4 },
  { 0x3F94F4F0 },
  { 0xB32E0212 },
  { 0x3F95C3FE },
  { 0x3386D6CC },
  { 0x3F96942E },
  { 0xB3C8DFE8 },
  { 0x3F97657E },
  { 0xB3B60E85 },
  { 0x3F9837F0 },
  { 0x33231B71 },
  { 0x3F990B88 },
  { 0xB26CC9F4 },
  { 0x3F99E046 },
  { 0xB359BE90 },
  { 0x3F9AB62A },
  { 0x33FC9500 },
  { 0x3F9B8D3A },
  { 0xB30C5563 },
  { 0x3F9C6574 },
  { 0xB397D13D },
  { 0x3F9D3EDA },
  { 0xB331A601 },
  { 0x3F9E196E },
  { 0x3244EA39 },
  { 0x3F9EF532 },
  { 0x33412342 },
  { 0x3F9FD228 },
  { 0x32959003 },
  { 0x3FA0B052 },
  { 0xB3F0468F },
  { 0x3FA18FAE },
  { 0x33CA8545 },
  { 0x3FA27044 },
  { 0xB3FCF3B7 },
  { 0x3FA35210 },
  { 0xB39717FD },
  { 0x3FA43516 },
  { 0xB323EC33 },
  { 0x3FA51958 },
  { 0xB37282C2 },
  { 0x3FA5FED6 },
  { 0x33A9B151 },
  { 0x3FA6E594 },
  { 0x33CFEEE8 },
  { 0x3FA7CD94 },
  { 0xB3162D36 },
  { 0x3FA8B6D6 },
  { 0xB3E984CE },
  { 0x3FA9A15A },
  { 0x33B4EA7C },
  { 0x3FAA8D26 },
  { 0x3325D921 },
  { 0x3FAB7A3A },
  { 0xB314AD82 },
  { 0x3FAC6896 },
  { 0x33A4BE40 },
  { 0x3FAD583E },
  { 0x33EA42A1 },
  { 0x3FAE4934 },
  { 0x3325946B },
  { 0x3FAF3B78 },
  { 0x33AD690A },
  { 0x3FB02F0E },
  { 0xB2D1247F },
  { 0x3FB123F6 },
  { 0xB37C5AA8 },
  { 0x3FB21A32 },
  { 0xB33333CE },
  { 0x3FB311C4 },
  { 0x32154889 },
  { 0x3FB40AAE },
  { 0x33A2654C },
  { 0x3FB504F4 },
  { 0xB3CC0622 },
  { 0x3FB60094 },
  { 0xB32F4254 },
  { 0x3FB6FD92 },
  { 0xB266B974 },
  { 0x3FB7FBF0 },
  { 0xB2D5CD70 },
  { 0x3FB8FBB0 },
  { 0xB3B89D04 },
  { 0x3FB9FCD2 },
  { 0x330A5817 },
  { 0x3FBAFF5A },
  { 0x33B2133E },
  { 0x3FBC034A },
  { 0x337DE5D4 },
  { 0x3FBD08A4 },
  { 0xB3414FE8 },
  { 0x3FBE0F68 },
  { 0x31986099 },
  { 0x3FBF179A },
  { 0xB3130B1A },
  { 0x3FC0213A },
  { 0x33A1F0D1 },
  { 0x3FC12C4C },
  { 0x33CA6671 },
  { 0x3FC238D2 },
  { 0x32C478F6 },
  { 0x3FC346CC },
  { 0x33DA2497 },
  { 0x3FC4563E },
  { 0x33CC5335 },
  { 0x3FC5672A },
  { 0x320AA837 },
  { 0x3FC67990 },
  { 0x33B5AA24 },
  { 0x3FC78D74 },
  { 0x33C8ABBA },
  { 0x3FC8A2D8 },
  { 0x33391FFC },
  { 0x3FC9B9BE },
  { 0xB37323A2 },
  { 0x3FCAD226 },
  { 0x333C8521 },
  { 0x3FCBEC14 },
  { 0x33FEF272 },
  { 0x3FCD078C },
  { 0xB3735F84 },
  { 0x3FCE248C },
  { 0x3228FC24 },
  { 0x3FCF4318 },
  { 0x33CF1919 },
  { 0x3FD06334 },
  { 0xB2944353 },
  { 0x3FD184E0 },
  { 0xB39DAE96 },
  { 0x3FD2A81E },
  { 0xB35C1DAA },
  { 0x3FD3CCF0 },
  { 0x3399859B },
  { 0x3FD4F35A },
  { 0x33ABCFEE },
  { 0x3FD61B5E },
  { 0xB0303219 },
  { 0x3FD744FC },
  { 0x33CAD69D },
  { 0x3FD8703A },
  { 0xB3B3924D },
  { 0x3FD99D16 },
  { 0xB2F61D41 },
  { 0x3FDACB94 },
  { 0x335E5594 },
  { 0x3FDBFBB8 },
  { 0xB3504A1C },
  { 0x3FDD2D82 },
  { 0xB375EF9B },
  { 0x3FDE60F4 },
  { 0x33825E0F },
  { 0x3FDF9612 },
  { 0x33DEB8F0 },
  { 0x3FE0CCDE },
  { 0x33EC2A95 },
  { 0x3FE2055A },
  { 0x33FFFE84 },
  { 0x3FE33F8A },
  { 0xB38D4176 },
  { 0x3FE47B6C },
  { 0x33A0373E },
  { 0x3FE5B906 },
  { 0x33E77C83 },
  { 0x3FE6F85A },
  { 0x33AAEE20 },
  { 0x3FE8396A },
  { 0x33207898 },
  { 0x3FE97C38 },
  { 0x3300D89F },
  { 0x3FEAC0C6 },
  { 0x33E7DD24 },
  { 0x3FEC0718 },
  { 0x33B64C1D },
  { 0x3FED4F30 },
  { 0x3276CCA1 },
  { 0x3FEE9910 },
  { 0xB34FE4BA },
  { 0x3FEFE4BA },
  { 0xB348464A },
  { 0x3FF13230 },
  { 0x33A7AD09 },
  { 0x3FF28178 },
  { 0xB3C3A600 },
  { 0x3FF3D290 },
  { 0xB2871670 },
  { 0x3FF5257E },
  { 0xB3EADB79 },
  { 0x3FF67A42 },
  { 0xB3938CC0 },
  { 0x3FF7D0E0 },
  { 0xB38CF52F },
  { 0x3FF9295A },
  { 0xB3094457 },
  { 0x3FFA83B2 },
  { 0x33DB722A },
  { 0x3FFBDFEE },
  { 0xB3931A0F },
  { 0x3FFD3E0C },
  { 0x31CF486C },
  { 0x3FFE9E12 },
  { 0xB3A38470 },

  { 0x3A6A6369 },
  { 0xBEB1C35D },
  { 0x3E246F69 },
  { 0xBDAB1EA1 },

  { 0x3F317218 },
  { 0x3E75FDF0 },
  { 0x3D635847 },

  { 0x7F000000 },
  { 0x00800000 },
  { 0x00000000 },
  { 0x3F800000 },
  { 0xBF800000 },

  { 0x47C00000 },

  { 0x3FB88000 },

  { 0x45800800 },

  { 0x5F800000 },
  { 0x1F800000 },
  { 0x00000000 },
  { 0x80000000 },
};



#endif  //__SVML_POWER_DATA_CL__
